<template>
	<transition
		:enter-class="$style.cardPanelEnter"
		:leave-to-class="$style.cardPanelLeaveTo"
		:enter-active-class="$style.cardPanelEnterActive"
		:leave-active-class="$style.cardPanelLeaveActive"
		enter-to-class=""
		leave-class=""
		appear
	>
		<AtomModalDialog :is-open="isCartOpen">
			<div
				id="cart-panel"
				role="dialog"
				:class="$style.cart"
				aria-modal="true"
				aria-labelledby="cart-panel-title"
				tabindex="-1"
				@click="close"
			>
				<GlobalEvents v-if="isCartOpen" @keydown.esc="close" />

				<div :class="$style.cartInner" @click.stop>
					<BaseScrollLock v-if="isCartOpen" />
					<div :class="$style.cartInnerContent">
						<transition name="fade-in-out">
							<div v-if="isWorkingNormalized" :class="$style.workingOverlay">
								<BaseSpinner :size="70" :ring-size="5" />
							</div>
						</transition>

						<div :class="$style.top">
							<h1 v-if="!isEmpty" id="cart-panel-title" :class="$style.topTitle">Your cart</h1>

							<button type="button" :class="$style.close" aria-label="Close the shopping cart" @click="close">
								<BaseIcon name="cross" title="Close" desc="Close the shopping cart" width="15" height="15" />
							</button>
						</div>

						<div v-if="isEmpty" :class="$style.empty">
							<h2 id="cart-panel-title" class="u-font-secondary" :class="$style.emptyHeading">Your cart is empty</h2>

							<div :class="$style.emptyIcon" aria-hidden="true">
								<BaseIcon name="cart-two" title="Shopping Cart" width="78" height="71" />
							</div>

							<BaseButton size="large" appearance="secondary" :class="$style.button" @click.native="close">
								Continue shopping
							</BaseButton>
						</div>

						<div v-else>
							<div :class="$style.items">
								<GlobalCartPanelUpsellSameDevice :cart-items="cart.items" :cart-discount="discount" />
								<div v-for="(product, index) in cart.items" :key="product.item_id">
									<div :class="[$style.product, { [$style.isContract]: product.isWarranty }]">
										<div :class="$style.productImageWrapper">
											<div :class="$style.productImage">
												<BaseImage
													:image="
														product.isWarranty
															? {
																	url:
																		'/prismic-images/molekule/c31654c3-49c8-4881-8f40-95b89960e4c8_clyde-icon-1%403x.png?auto=compress,format',
																	height: 72,
																	width: 72,
															  }
															: product.image
													"
													:aspect="1"
													contain
													:sizes="product.isWarranty ? '24px' : '76px'"
													alt=""
												/>
											</div>
										</div>

										<div :class="$style.productInfo">
											<h3 v-if="product.name" class="u-font-secondary" :class="$style.productName">
												{{ product.name }}
											</h3>

											<p v-if="product.description" :class="$style.productText">
												{{ product.description }}
											</p>

											<AtomTransitionExpand>
												<div v-if="product.hasSubscription && !isGiftPurchase" :class="$style.productRefills">
													Features auto-refills
													<div v-if="product.subscriptionInfo" :class="$style.productRefillsTooltipWrapper">
														<BaseTooltip theme="light" position="top left" :width="180">
															<div
																v-rich-content
																:class="$style.productRefillsTooltipContent"
																v-html="product.subscriptionInfo"
															></div>
														</BaseTooltip>
													</div>
												</div>
											</AtomTransitionExpand>

											<div :class="$style.productQty">
												<button
													:class="$style.productQtyButton"
													aria-label="Decrement"
													@click="updateQty(product.item_id, product.qty - 1, product)"
													>-</button
												>
												<div v-if="!renderQtyFieldAsInput && product.qty <= 9" :class="$style.productQtySelectWrapper">
													<select
														:aria-label="`${product.name} quantity`"
														:value="product.qty"
														:class="$style.productQtySelect"
														@change="updateQty(product.item_id, parseInt($event.target.value), product)"
													>
														<option
															v-for="n in product.isWarranty && product.maxQuantity
																? Math.min(product.maxQuantity + 1, 11)
																: 11"
															:key="n"
															:value="n === 11 ? '10+' : n - 1"
														>
															{{ n === 11 ? '10+' : n - 1 }}
														</option>
													</select>
													<span aria-hidden="true" :class="$style.productQtySelectText">{{ product.qty }}</span>
												</div>
												<GlobalCartPanelQtyInput
													v-else
													:ref="`qty-input-${index}`"
													:aria-label="`${product.name} quantity`"
													:input-class="$style.productQtyInput"
													:value="product.qty"
													@update-qty="($event) => updateQty(product.item_id, $event, product, `qty-input-${index}`)"
												/>
												<button
													:class="$style.productQtyButton"
													aria-label="Increment"
													:disabled="product.isWarranty && product.maxQuantity && product.qty === product.maxQuantity"
													@click="updateQty(product.item_id, product.qty + 1, product)"
												>
													+
												</button>
											</div>
										</div>

										<div :class="$style.productPrice">
											<span v-if="false">
												<span class="u-visuallyhidden">regular price</span>
												<span :class="$style.listPriceWrapper"
													><span :class="$style.listPrice">${{ product.listPrice | numberWithCommas }}</span></span
												>
												<span class="u-visuallyhidden">sale price</span>
											</span>
											{{ currencySymbol }}{{ product.price.toFixed(2) | numberWithCommas }}
										</div>

										<div :class="$style.productRemove">
											<button
												:class="$style.productRemoveButton"
												:aria-label="`Remove ${product.name} product`"
												@click="remove(product.item_id, product)"
											>
												<div>
													<BaseIcon :class="$style.productRemoveIcon" name="cross" title="Remove Product" />
												</div>
											</button>
										</div>
									</div>

									<div
										v-if="
											$store.state.locale === 'en-us' && !product.isWarranty && skusWithWarranties.includes(product.sku)
										"
										:id="`clyde-${product.sku}`"
										ref="clydeCtaContainers"
										:class="$style.clydeContainer"
										:data-sku="product.sku"
										:data-qty="product.qty"
										:data-clyde-loaded="false"
									/>
								</div>
								<GlobalCartPanelUpsellDifferentDevices :cart-items="cart.items" :cart-discount="discount" />
							</div>

							<FormCheckbox
								label-for="gift-checkbox"
								:class="$style.giftCheckbox"
								:checked="isGiftPurchase"
								@change="handleGiftCheck"
							>
								<span :class="$style.giftCheckboxLabel">
									This is a gift
									<div :class="$style.giftCheckboxImage">
										<BaseImage
											:image="{
												url:
													'/prismic-images/molekule/a5b610dc-1013-4a5a-bf93-eb7b2993e324_gift-icon-sidecart%403x.png?auto=compress,format',
												height: 75,
												width: 75,
											}"
										/>
									</div>
								</span>
							</FormCheckbox>

							<dl :class="$style.pricing">
								<div v-if="discount" :class="[$style.pricingLine, $style.discount]">
									<dt :class="$style.pricingCol">Discount</dt>
									<dd :class="$style.pricingCol">-{{ currencySymbol }}{{ discount.toFixed(2) | numberWithCommas }}</dd>
								</div>
								<div v-if="cart.couponCode" :class="[$style.pricingLine, $style.notBold]">
									<dt :class="$style.pricingCol">Promo code</dt>
									<dd :class="$style.pricingCol">{{ cart.couponCode }}</dd>
								</div>
								<div :class="$style.pricingLine">
									<dt :class="$style.pricingCol">Total</dt>
									<dd :class="$style.pricingCol">{{ currencySymbol }}{{ total.toFixed(2) | numberWithCommas }}</dd>
								</div>
							</dl>

							<div :class="$style.infoFirst">
								<BlockAffirm :class="$style.finance" :price="total" />
							</div>

							<BaseButton
								size="large"
								appearance="secondary"
								:class="$style.button"
								:href="cart.connectUrl"
								@click.native="handleCheckoutClick"
							>
								Checkout
							</BaseButton>

							<div v-if="couponCodeError" :class="$style.infoSecond">
								<p>{{ couponCodeError }}</p>
							</div>

							<div :class="$style.infoSecond">
								<p>Taxes and shipping calculated at checkout.</p>
							</div>
						</div>
					</div>
				</div>
			</div>
		</AtomModalDialog>
	</transition>
</template>

<script>
import AtomModalDialog from '@components/atom-modal-dialog';
import GlobalCartPanelUpsellSameDevice from '@components/global-cart-panel-upsell-same-device';
import GlobalCartPanelUpsellDifferentDevices from '@components/global-cart-panel-upsell-different-devices';
import GlobalCartPanelQtyInput from '@components/global-cart-panel-qty-input';
import AtomTransitionExpand from '@components/atom-transition-expand';
import FormCheckbox from '@components/form-checkbox';
import BlockAffirm from '@components/block-affirm';
import { mapGetters, mapState } from 'vuex';
import isEqual from 'lodash/isEqual';
import debounce from 'lodash/debounce';

export default {
	components: {
		AtomModalDialog,
		GlobalCartPanelUpsellSameDevice,
		GlobalCartPanelUpsellDifferentDevices,
		GlobalCartPanelQtyInput,
		AtomTransitionExpand,
		FormCheckbox,
		BlockAffirm,
	},

	props: {
		isCartOpen: {
			type: Boolean,
			default: false,
		},
	},

	data() {
		return {
			isWorking: false,
			renderQtyFieldAsInput: false,
			debouncedCartWatchHandler: debounce(this.cartWatchHandler, 100),
		};
	},

	computed: {
		...mapGetters('magento', ['cart', 'skusWithWarranties']),
		...mapGetters(['currencySymbol']),
		...mapState('magento', ['cartIsLoading', 'couponCodeError', 'isGiftPurchase']),

		isEmpty() {
			return !this.cart || this.cart.items.length === 0;
		},

		total() {
			const { cart } = this;
			if (!cart) return 0;
			return cart.totals.grand_total || 0;
		},

		discount() {
			const { cart } = this;
			if (!cart) return 0;
			return Math.ceil(Math.abs(cart.totals.discount) || 0);
		},

		isWorkingNormalized() {
			return this.isWorking || this.cartIsLoading;
		},

		cartHasGiftOrderValue() {
			return this.cart && (this.cart.giftOrder || this.cart.giftOrder === false);
		},
	},

	watch: {
		cart: {
			immediate: true,
			handler: 'debouncedCartWatchHandler',
		},
	},

	methods: {
		close() {
			this.$emit('close');
		},

		updateQty(itemId, qty, product, inputRef) {
			if (product.isWarranty && product.maxQuantity && qty > product.maxQuantity) {
				if (inputRef) {
					this.$refs[inputRef][0].refUpdateQty(product.qty);
				}
				return;
			}

			if (qty === '10+') {
				this.renderQtyFieldAsInput = true;
				return;
			} else if (this.renderQtyFieldAsInput) {
				this.renderQtyFieldAsInput = false;
			}

			if (qty === product.qty || this.isWorking) return;

			if (qty === 0) {
				return this.remove(itemId, product);
			}
			const { sku, qty: currentQty } = product;
			this.isWorking = true;
			this.$store
				.dispatch('magento/UPDATE_QUANTITY', { itemId, qty })
				.then(() => {
					const isUp = qty > currentQty;
					this.$tealiumEvent(`quantity_${isUp ? 'in' : 'de'}crease`, {
						event_category: 'Cart',
						event_action: 'Changed Quantity',
						event_label: `${isUp ? 'In' : 'De'}creased`,
						productsData: [{ sku, qty: Math.abs(currentQty - qty) }],
					});
				})
				.finally(() => {
					this.isWorking = false;
				});
		},

		remove(itemId, { sku, qty }) {
			this.isWorking = true;
			this.$store
				.dispatch('magento/REMOVE_FROM_CART', { itemId })
				.then(() => {
					this.$tealiumEvent('cart_remove', {
						event_category: 'Cart',
						event_action: 'Removed from Cart',
						event_label: `Removed: ${sku}`,
						productsData: [{ sku, qty }],
					});
				})
				.finally(() => {
					this.isWorking = false;
				});
		},

		async handleCheckoutClick(e) {
			e.preventDefault();
			try {
				this.$tealiumEvent('begin_checkout_click', {
					event_category: 'Cart',
					event_action: 'Clicked Begin Checkout',
				});

				await this.$store.dispatch('magento/UPDATE_GIFT_ATTRIBUTE', this.isGiftPurchase);
			} catch (e) {
				console.error(e);
				this.$sentry.captureException(e);
			} finally {
				window.location.href = this.cart.connectUrl;
			}
		},

		handleGiftCheck(checked) {
			const { 'magento/cart': cart } = this.$store.getters;
			const cartTotal = ((cart && cart.totals && cart.totals.grand_total) || 0).toFixed(2);

			this.$store.commit('magento/SET_IS_GIFT_PURCHASE', checked);

			if (!this.cartHasGiftOrderValue) {
				localStorage.setItem(this.$store.state.magento.giftCheckboxStorageName, checked);
			}

			this.$tealiumEvent(`clicked_gift_o${checked ? 'n' : 'ff'}`, {
				event_category: 'Gift Purchase',
				event_action: `${checked ? 'C' : 'Un-c'}hecked sidecart gift box`,
				event_value: cartTotal,
			});
		},

		cartWatchHandler(newCart, oldCart) {
			const { items = [] } = newCart || {};
			const { oldItems = [] } = oldCart || {};
			if (items.length && !isEqual(items, oldItems)) {
				this.$nextTick(() => {
					(this.$refs.clydeCtaContainers || []).forEach(async (container) => {
						if (items.some((item) => item.associatedProductSku === container.dataset.sku)) {
							if (container.dataset.clydeLoaded === 'true') {
								container.innerHTML = '';
								container.dataset.clydeLoaded = 'false';
							}
							return;
						}

						if (container.dataset.clydeLoaded === 'true') return;

						await this.$clyde('appendToSelectorWithSku', container.dataset.sku, `#${container.id}`, async () => {
							const cartTotal = ((newCart && newCart.totals && newCart.totals.grand_total) || 0).toFixed(2);

							this.$tealiumEvent('clicked_warranty_sidecart', {
								event_category: 'Warranty',
								event_action: 'Clicked sidecart CTA Warranty',
								event_label: [container.dataset.sku],
								event_value: [cartTotal],
								referral_partner: 'Clyde',
								referral_url: `https://molekule.com/add-to-cart?skus=${container.dataset.sku}`,
							});

							const selectedContract = await this.$clyde('getSelectedContract');
							if (!selectedContract) {
								this.$tealiumEvent('clicked_warranty_no', {
									event_category: 'Warranty',
									event_action: 'Closed Modal no cart_add',
									event_label: [container.dataset.sku],
									event_value: [cartTotal],
									referral_partner: 'Clyde',
									referral_url: `https://molekule.com/add-to-cart?skus=${container.dataset.sku}`,
								});
								return;
							}

							this.isWorking = true;
							this.$store
								.dispatch('magento/ADD_TO_CART', {
									items: [
										{
											...selectedContract,
											qty: Number(container.dataset.qty),
											isContract: true,
											contractAssociatedSku: container.dataset.sku,
										},
									],
									promoCode: this.promoCode,
								})
								.finally(() => (this.isWorking = false));
						});

						container.dataset.clydeLoaded = true;
					});
				});
			}
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.cart {
	display: flex;
	justify-content: flex-end;
	width: 100%;
	height: 100%;
	cursor: pointer;
	background-color: rgba(color('black'), 0.2);
}
// stylelint-disable-next-line no-descending-specificity
.cartInner {
	flex: 0 0 auto;
	width: 100%;
	max-width: 46rem;
	overflow-x: hidden;
	overflow-y: auto;
	cursor: default;
	background-color: color('white');
	-webkit-overflow-scrolling: touch;

	:global {
		.fade-in-out-leave-active {
			top: 6rem;
		}
		.fade-enter,
		.fade-leave-to,
		.fade-in-out-enter,
		.fade-in-out-leave-to {
			opacity: 0;
		}

		.fade-in-out-leave,
		.fade-in-out-enter-to {
			opacity: 0.6;
		}
	}
}

.cartInnerContent {
	position: relative;
	padding: 0 size('s') size('m');

	@include above('medium') {
		padding-right: size('m');
		padding-left: size('m');
	}
}

.workingOverlay {
	position: absolute;
	top: 6rem;
	left: 0;
	z-index: 1;
	display: flex;
	align-items: center;
	justify-content: center;
	width: 100%;
	height: calc(100% - 6rem);
	background-color: color('white');
	opacity: 0.6;
}

// Top
.top {
	display: flex;
	align-items: center;
}

.topTitle {
	@include use-text-style('type');
	@include use-text-style('type-100');

	@include above('medium') {
		@include use-text-style('type-200');
	}
}

.close {
	padding: 2.2rem;
	margin-right: -2.2rem;
	margin-left: auto;
}

.button {
	display: block;
	width: 100%;
}

// Empty
.empty {
	text-align: center;
}

.emptyHeading {
	margin-bottom: size('l');

	@include use-text-style('heading-200');
}

.emptyIcon {
	margin-bottom: size('l');
}

// Products
.items {
	padding-bottom: size('m') - size('s');
	border-bottom: 1px solid color('border');
}

.giftCheckbox {
	align-items: center;
	padding: 3.7rem 0 0;

	[class^='labelText'] {
		width: 100%;
	}

	.giftCheckboxLabel {
		@include use-text-style('type-200');

		display: flex;
		align-items: center;
		justify-content: space-between;
	}

	.giftCheckboxImage {
		width: 2.5rem;
	}
}

.product {
	position: relative;
	display: flex;
	flex-wrap: wrap;
	padding: 2rem 0;

	&.isContract {
		padding: 0 0 2rem;
	}
}

.productImageWrapper {
	display: flex;
	flex: 0 0 auto;
	justify-content: center;
	width: 7.6rem;
	margin-right: size('xs');
}

.productImage {
	width: 100%;

	.isContract & {
		width: 2.4rem;
	}
}

.listPriceWrapper {
	color: color('red');
	text-decoration: line-through;

	@include above('medium') {
		display: block;
	}
}

.listPrice {
	color: color('primary-200');
}

.productInfo {
	flex: 1 1 auto;
}

.productName {
	@include use-text-style('heading-100');

	.isContract & {
		@include use-text-style('type-100');

		font-family: font-family('primary');
		line-height: 1.7143;
		color: color('primary');
	}
}

.productText,
.productRefills,
.productPrice {
	@include use-text-style('type');
	@include use-text-style('type-100');
}

.productText {
	font-weight: 300;
}

.productQty {
	@include use-text-style('type-500');

	display: flex;
	align-items: center;
}

.productQtySelectWrapper {
	position: relative;
	display: inline-block;
	width: 3.5rem;
	height: 1.23em;
}

.productQtySelectText {
	position: absolute;
	top: 0;
	left: 0;
	width: 100%;
	height: 100%;
	text-align: center;
	pointer-events: none;
}

.productQtySelect {
	position: absolute;
	top: 0;
	left: 0;
	display: inline-block;
	width: auto;
	height: 100%;
	padding: 0 0 0 1rem;
	cursor: pointer;
	background: 0;
	border: 0;
	opacity: 0;
}

.productQtySelect:focus + .productQtySelectText {
	outline: auto;
}

.productQtyButton {
	padding: 0.2rem;
}

.productQtyInput {
	width: 3.5rem !important;
	padding: 0 !important;
	text-align: center !important;
	border: none !important;
	&::-webkit-inner-spin-button,
	&::-webkit-outer-spin-button {
		margin: 0;
		-webkit-appearance: none;
	}
}

.productRefillsTooltipWrapper {
	position: relative;
	top: 0.3rem;
	display: inline-block;
	padding-left: 0.2rem;
}

.productPrice {
	@include use-text-style('type-200');

	text-align: right;
}

.productRemove {
	position: absolute;
	right: -1rem;
	bottom: 1.7rem;
}

.productRemoveButton {
	padding: size('xxs');
}

.clydeContainer {
	flex: 1;
	margin: 0 2.1rem 0 9.1rem;

	iframe {
		margin: calc(-0.5rem - 5px) 0 calc(1rem + 5px);
	}
}

.productRemoveIcon {
	display: block;
	width: 1rem;
	height: 1rem;
	fill: #d7d5d4;
}

// Pricing
.pricing {
	padding-top: 3.1rem;
	margin-bottom: size('m');

	@include above('medium') {
		padding-top: 2.8rem;
	}
}

.pricingLine {
	display: flex;
	justify-content: space-between;
	margin-bottom: size('m');
	font-weight: 700;

	@include use-text-style('type');
	@include use-text-style('type-200');

	&.discount {
		padding: size('xxs');
		margin-right: -1 * size('xxs');
		margin-left: -1 * size('xxs');
		font-weight: 300;
		line-height: 1;
		background-color: color('secondary-300');
		border-radius: 0.4rem;
	}

	&.notBold {
		font-weight: 300;
	}
}

// Info
.infoFirst,
.infoSecond {
	font-weight: 300;
	text-align: center;

	@include use-text-style('type');
	@include use-text-style('type-100');

	a {
		font-weight: normal;
	}
}

.infoFirst {
	margin-bottom: size('m');
}

.infoSecond {
	margin-top: size('m');
}

.cardPanelLeaveActive,
.cardPanelEnterActive {
	transition-duration: time('slow');

	.cart {
		transition: background-color time('slow');
	}

	.cartInner {
		transition: transform time('slow');
	}
}

.cardPanelEnter,
.cardPanelLeaveTo {
	.cart {
		background-color: rgba(color('black'), 0);
	}

	.cartInner {
		transform: translateX(100%);
	}
}
</style>
